<?php

/**
 * facilidad_pago actions.
 *
 * @package    cobro_coactivo
 * @subpackage facilidad_pago
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class facilidad_pagoActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_FACILIDAD_PAGO_V',
        'CBR_PROCESO_COACTIVO',
        'CBR_AVOCA_CONOC',
        'CBR_REMISION_TITULO',
        'CBR_TITULO_MINERO_V',
        'CBR_ACTUALIZA_TITULO_V',
        'CBR_TIPO_DOCUMENTO',
        'CBR_ABOGADO_ULT_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CBR_PROCESO_COACTIVO,LEFT' =>
        array(
            'id_proceso_coactivo' => 'CBR_FACILIDAD_PAGO_V'
        ),
        'CBR_REMISION_TITULO,LEFT' =>
        array(
            'id_remision_titulo' => 'CBR_FACILIDAD_PAGO_V'
        ),
        'CBR_AVOCA_CONOC,LEFT' =>
        array(
            'id_avoca_conoc' => 'CBR_FACILIDAD_PAGO_V'
        ),
        'CBR_TITULO_MINERO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_ACTUALIZA_TITULO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_TIPO_DOCUMENTO,LEFT' =>
        array(
            'id_tipo_documento' => 'CBR_AVOCA_CONOC'
        ),
        'CBR_ABOGADO_ULT_V,LEFT' =>
        array(
            'id_remision_titulo' => 'CBR_REMISION_TITULO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_FACILIDAD_PAGO_V' =>
        array(
            'id_facilidad_pago' => 'id_facilidad_pago',
            'id_proceso_coactivo' => 'id_proceso_coactivo',
            'id_avoca_conoc' => 'id_avoca_conoc',
            'fecha_registro' => 'fecha_registro',
            'id_remision_titulo' => 'id_remision_titulo',
            'estado' => 'estado',
            'incumplimiento' => 'incumplimiento',
            'fecha_log' => 'fecha_log',
            'usuario_log' => 'usuario_log'
        ),
        'CBR_PROCESO_COACTIVO' =>
        array(
            'no_proceso' => 'no_proceso',
            'fecha' => 'fecha_coactivo',
            'id_anhos' => 'id_anhos'
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'numero_remision' => 'numero_remision',
            'anho_remision' => 'anho_remision',
            'fecha_remision' => 'fecha_remision',
            'estado' => 'estado_remision',
            'cod_titulo' => 'cod_titulo'
        ),
        'CBR_AVOCA_CONOC' =>
        array(
            'no_auto' => 'no_auto',
            'fecha' => 'fecha',
            'observaciones' => 'observaciones',
            'id_tipo_documento' => 'id_tipo_documento'
        ),
        'CBR_TITULO_MINERO_V' =>
        array(
            'mineral' => 'mineral_deb',
            'id_debito' => 'id_debito',
            'id_mineral' => 'id_mineral_deb'
        ),
        'CBR_ACTUALIZA_TITULO_V' =>
        array(
            'mineral' => 'mineral',
            'id_mineral' => 'id_mineral',
            'cod_mineral' => 'cod_mineral'
        ),
        'CBR_TIPO_DOCUMENTO' =>
        array(
            'descripcion' => 'descripcion_tipdoc'
        ),
        'CBR_ABOGADO_ULT_V' =>
        array(
            'id_abogado' => 'id_abogado',
            'num_doc' => 'num_doc',
            'razon_soc' => 'razon_soc'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'anho_remision desc', 'cod_titulo', 'fecha_registro desc', 'no_proceso', 'no_auto', 'id_facilidad_pago'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_FACILIDAD_PAGO_V' =>
        array(
            'id_facilidad_pago,a' => array('!=' => array(-1)),
            'id_facilidad_pago,b' => array('=' => array('id_facilidad_pago')),
            'fecha_registro' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'id_proceso_coactivo' => array('=' => array('id_proceso_coactivo')),
            'id_avoca_conoc' => array('=' => array('id_avoca_conoc')),
            'id_remision_titulo' => array('=' => array('id_remision_titulo')),
            'estado' => array('=' => array('estado')),
            'incumplimiento' => array('=' => array('incumplimiento')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'CBR_PROCESO_COACTIVO' =>
        array(
            'no_proceso' => array('=' => array('no_proceso'))
        ),
        'CBR_AVOCA_CONOC' =>
        array(
            'no_auto' => array('=' => array('no_auto'))
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'cod_titulo' => array('=' => array('cod_titulo')),
            'id_par' => array('=' => array('id_par')),
            'numero_remision' => array('=' => array('numero_remision')),
            'anho_remision' => array('=' => array('id_anhos')),
            'numero_correpondencia' => array('=' => array('numero_correpondencia'))
        ),
        'CBR_ABOGADO_ULT_V' =>
        array(
            'id_abogado' => array('=' => array('id_abogado')),
            'num_doc' => array('=' => array('num_doc'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_facilidad_pago'; //identificador de la tabla
    protected $id_names = array('id_facilidad_pago'); //llave primaria
    protected $field_names = array('id_proceso_coactivo', 'fecha_registro',
        'id_avoca_conoc', 'estado', 'incumplimiento', 'usuario_log'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_FACILIDAD_PAGO'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_facilidad_pago'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            //Campos de log - 20200507
            $request['usuario_log'] = $request['id_username'];
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;


        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
